<?php
require_once($_SERVER['DOCUMENT_ROOT'] . "/session.php");

$tablename = isset($_REQUEST['tablename']) ? $_REQUEST['tablename'] : '';
$mode = isset($_REQUEST['mode']) ? $_REQUEST['mode'] : '';

header("Content-Type: application/json");  // JSON 콘텐츠 유형 설정

require_once($_SERVER['DOCUMENT_ROOT'] . "/lib/mydb.php");
$pdo = db_connect();

include "_request.php";

// search_tag 업데이트
$search_tag = $prodcode . ' ' .
             $railtype . ' ' .
             $boxsize . ' ' .
             $boxexit . ' ' .
             $reg_date . ' ' .
             $author . ' ' .
             $remark . ' ';

if ($mode == "modify") {
    $update_log = date("Y-m-d H:i:s") . " - " . $_SESSION["name"] . " " . $update_log . "&#10";
    try {
        $pdo->beginTransaction();
        // SQL 쿼리 생성 (업데이트)
        $sql = "UPDATE " . $DB . "." . $tablename . " SET ";
        $sql .= "reg_date = ?, author = ?, remark = ?, update_log = ?, search_tag = ?, prodcode = ?, railtype = ?, boxsize = ?, boxexit = ?, frontbottom = ?, railwidth = ? ";
        $sql .= "WHERE num = ? LIMIT 1"; // num이 일치하는 하나의 레코드만 업데이트

        $stmh = $pdo->prepare($sql);

        // 변수 바인딩
        $stmh->bindValue(1, $reg_date, PDO::PARAM_STR);
        $stmh->bindValue(2, $author, PDO::PARAM_STR);
        $stmh->bindValue(3, $remark, PDO::PARAM_STR);
        $stmh->bindValue(4, $update_log, PDO::PARAM_STR);
        $stmh->bindValue(5, $search_tag, PDO::PARAM_STR);
        $stmh->bindValue(6, $prodcode, PDO::PARAM_STR);
        $stmh->bindValue(7, $railtype, PDO::PARAM_STR);
        $stmh->bindValue(8, $boxsize, PDO::PARAM_STR);
        $stmh->bindValue(9, $boxexit, PDO::PARAM_STR);
        $stmh->bindValue(10, $frontbottom, PDO::PARAM_INT);
        $stmh->bindValue(11, $railwidth, PDO::PARAM_INT);
        $stmh->bindValue(12, $num, PDO::PARAM_INT);

        // 실행
        $stmh->execute();
        $pdo->commit();
    } catch (PDOException $Exception) {
        $pdo->rollBack();
        print "오류: " . $Exception->getMessage();
    }
}

else if ($mode == "insert" || $mode == '' || $mode == null) {
    $update_log = date("Y-m-d H:i:s") . " - " . $_SESSION["name"] . " " . $update_log . "&#10";
	$author = $user_name;
    // 데이터 삽입
    try {
        $pdo->beginTransaction();
		
		$reg_date = date("Y-m-d");

        // SQL 쿼리 생성 (삽입)
        $sql = "INSERT INTO " . $DB . "." . $tablename . " (";
        $sql .= "reg_date, author, remark, update_log, search_tag, prodcode, railtype, boxsize, boxexit, frontbottom, railwidth ";
        $sql .= ") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

        $stmh = $pdo->prepare($sql);

        // 변수 바인딩
        $stmh->bindValue(1, $reg_date, PDO::PARAM_STR);
        $stmh->bindValue(2, $author, PDO::PARAM_STR);
        $stmh->bindValue(3, $remark, PDO::PARAM_STR);
        $stmh->bindValue(4, $update_log, PDO::PARAM_STR);
        $stmh->bindValue(5, $search_tag, PDO::PARAM_STR);
        $stmh->bindValue(6, $prodcode, PDO::PARAM_STR);
        $stmh->bindValue(7, $railtype, PDO::PARAM_STR);
        $stmh->bindValue(8, $boxsize, PDO::PARAM_STR);
        $stmh->bindValue(9, $boxexit, PDO::PARAM_STR);
        $stmh->bindValue(10, $frontbottom, PDO::PARAM_INT);
        $stmh->bindValue(11, $railwidth, PDO::PARAM_INT);

        // 실행
        $stmh->execute();
        $pdo->commit();
    } catch (PDOException $Exception) {
        $pdo->rollBack();
        print "오류: " . $Exception->getMessage();
    }
}

else if ($mode == "delete") { // 데이터 삭제
    try {
        $pdo->beginTransaction();
        $sql = "UPDATE " .  $DB . "." . $tablename . " SET is_deleted=1 WHERE num = ?";  
        $stmh = $pdo->prepare($sql);
        $stmh->bindValue(1, $num, PDO::PARAM_INT);      
        $stmh->execute();
        $pdo->commit();
    } catch (PDOException $ex) {
        $pdo->rollBack();
        print "오류: ".$ex->getMessage();
    }
}

$data = [   
 'num' => $num,
 'mode' => $mode
]; 

echo json_encode($data, JSON_UNESCAPED_UNICODE);

?>
